function [averageRate confusionMatrix correctRate] = getConfusionMatrix(tssMat,pos)

[nD nC] = size(tssMat);
confusionMatrix = zeros(nC,nC);
% NN classifier
decision = zeros(size(tssMat,1),nC);
for i = 1:size(tssMat,1)
    [junk ind] = max(tssMat(i,:));
    decision(i,ind(1)) = 1;
end

% Evaluation
offset = 0;
for iC = 1:nC
    ind1 = offset+(1:length(pos{iC})); % ground truth positives
    for jC = 1:nC
        ind2 = find(decision(:,jC)); % positive returned by classifier jC
        confusionMatrix(iC,jC) = length(intersect(ind1,ind2)); % number of iC-items classified as jC
    end
    offset = offset + length(pos{iC});
end

numTest = zeros(1,nC);
for iC = 1:nC
    correctRate(iC) = confusionMatrix(iC,iC) / sum(confusionMatrix(iC,:));
    numTest(iC) = length(pos{iC});
end

averageRate = sum(correctRate)/nC;
