function [averageRate confusionMatrix correctRate] = getConfusionMatrixSoft(postMat,pos)
% Make soft decision from label posterior

[nD nC] = size(postMat);
confusionMatrix = zeros(nC,nC);
% NN classifier
decision = zeros(size(postMat,1),nC);
for i = 1:size(postMat,1)
    [junk ind] = max(postMat(i,:));
    decision(i,ind(1)) = 1;
end

% Evaluation
offset = 0;
for iC = 1:nC
    ind1 = offset+(1:length(pos{iC})); % ground truth positives
    for imID = ind1
    	for jC = 1:nC
    		confusionMatrix(iC,jC) = confusionMatrix(iC,jC) + postMat(imID,jC);
    	end
    end
    offset = offset + length(pos{iC});
end

numTest = zeros(1,nC);
for iC = 1:nC
    correctRate(iC) = confusionMatrix(iC,iC) / sum(confusionMatrix(iC,:));
    numTest(iC) = length(pos{iC});
end

averageRate = sum(correctRate)/nC;
