clear
close all
load('Split/categoryInfo.mat','categories');
load('Split/Natural/split.mat','negTestImages');
nC = length(categories);
overwrite = true;
methodName = 'ActiveBasisInvariantMT';
displayModeIsOn = 0;

norient = 16;
nSk = 80; % number of sketch features to display
nTex = 10; % number of texture features to display
windowSize = 150;
numCluster = 3;

selected_runs = [21];

% illustrate matched templates
for iCat = 1:20
    category = categories{iCat};
    for iRun = selected_runs
		% load template and matching result
        load( sprintf( 'Result/%s/%s/model_run%d.mat', categories{iCat}, methodName, iRun ) );
        file0 = sprintf('Split/%s/split%d.mat',category,iRun);
        load(file0,'posTrainImages');
        matchedSketch = cell(1,length(posTrainImages));
        
        for cluster_ind = 1:numCluster
            image_ind = find( cluster_assigment == cluster_ind );
            matchedSketch = {}; images = {};
            count = 1 ;
            for i = image_ind

                load(sprintf('Feature/%s/%s/%s.mat',...
                    'GaborS1',category,posTrainImages{i}),...
                    'ARGMAX1LocalNorm','M1RowShift',...
                    'M1ColShift', 'M1OriShifted',...
                    'S1LocalNorm', 'RANGE');
                S1LocalNorm = convert2float(S1LocalNorm,RANGE);
                for o = 1:norient
                    tmp = inscribe([windowSize windowSize],S1LocalNorm{o},0);
                    S1LocalNorm{o} = tmp;
                    tmp = inscribe([windowSize windowSize],ARGMAX1LocalNorm{o},-100);
                    ARGMAX1LocalNorm{o} = tmp;
                end
                
                srcImg = imread( sprintf('Image/%s/%s',category,posTrainImages{i}) );
                if size(srcImg,3) == 3
                    srcImg = rgb2gray( srcImg );
                end
                srcImg = double( imresize( srcImg, [windowSize, windowSize] ) );

                T = S2Template{ cluster_ind };

                templateScaleInd = 0;

                rowScale = 2^0;
                colScale = 2^0;
                row_shift = current_row_translation(i);
                col_shift = current_col_translation(i);
                rotation = current_rotation(i);
                reflect = current_reflection(i);
                [tmpSelectedRow tmpSelectedCol tmpSelectedOri tmpSelectedScale] = ...
                    mexc_TemplateAffineTransform( templateScaleInd, rowScale,...
                    colScale, rotation, single(T.selectedRow), single(T.selectedCol),...
                    single(T.selectedOri), single(T.selectedScale), norient );

                TT.selectedRow = tmpSelectedRow;
                tmpSelectedCol = tmpSelectedCol * reflect;
                TT.selectedCol = tmpSelectedCol;
                if reflect < 0
                    tmpSelectedOri = norient - tmpSelectedOri;
                end
                tmpSelectedOri(tmpSelectedOri>=norient) = 0;
                TT.selectedOri = tmpSelectedOri;
                TT.selectedScale = tmpSelectedScale;
                TT.selectedLambda = single(T.selectedLambda);
                TT.selectedLogZ = single(T.selectedLogZ);
                TT.subsampleM1 = T.subsampleM1;

                % render the matched template
                for iF = 1:nSk
                    tmp_row = row_shift+TT.selectedRow(iF)+1;
                    tmp_col = col_shift+TT.selectedCol(iF)+1;
                    if tmp_row <= 0 || tmp_row > windowSize || tmp_col <= 0 || tmp_col > windowSize
                        shifted_row(iF) = 1;
                        shifted_col(iF) = 1;
                        shifted_ori(iF) = 0;
                        response_vec(iF) = 0;
                        continue;
                    end
                    ind_shift = 1 + ARGMAX1LocalNorm{TT.selectedOri(iF)+1}(tmp_row,tmp_col);
                    if ind_shift < 0
                        shifted_row(iF) = 1;
                        shifted_col(iF) = 1;
                        shifted_ori(iF) = 0;
                        response_vec(iF) = 0;
                        continue;
                    end
                    shifted_row(iF) = double(M1RowShift{TT.selectedOri(iF)+1}(ind_shift)) + row_shift + TT.selectedRow(iF) + 1;
                    shifted_col(iF) = double(M1ColShift{TT.selectedOri(iF)+1}(ind_shift)) + col_shift + TT.selectedCol(iF) + 1;
                    shifted_ori(iF) = double(M1OriShifted{TT.selectedOri(iF)+1}(ind_shift));
                    response_vec(iF) = double( S1LocalNorm{shifted_ori(iF)+1}(shifted_row(iF),shifted_col(iF)) );
                end
                sym = displayGaborTemplate([windowSize windowSize], shifted_row,...
                    shifted_col,...
                    shifted_ori,...
                    response_vec...
                    );
                matchedSketch{count} = sym;
                images{count} = srcImg;
                count = count + 1;
            end
            im_sketch = displayImages( [images(:)';matchedSketch(:)'], 2*5, 100, 100 );
            imwrite( im_sketch, sprintf( 'matched_%s_run%d_cluster%d_sk.png', category, iRun, cluster_ind ) );
            
            
%             matchedTexture = {};
%             count = 1 ;
%             for i = image_ind
% 
%                 load(sprintf('Feature/%s/%s/%s.mat',...
%                     'GaborS1',category,posTrainImages{i}),...
%                     'S1LocalMean', 'RANGE');
%                 S1LocalNorm = convert2float(S1LocalNorm,RANGE);
%                 for o = 1:norient
%                     tmp = inscribe([windowSize windowSize],S1LocalMean{o},0);
%                     S1LocalMean{o} = tmp;
%                 end
%                 
%                 
% 
%                 T = S2TemplateTexture{ cluster_ind };
% 
%                 templateScaleInd = 0;
% 
%                 rowScale = 2^0;
%                 colScale = 2^0;
%                 row_shift = current_row_translation(i);
%                 col_shift = current_col_translation(i);
%                 rotation = current_rotation(i);
%                 reflect = current_reflection(i);
%                 [tmpSelectedRow tmpSelectedCol tmpSelectedOri tmpSelectedScale] = ...
%                     mexc_TemplateAffineTransform( templateScaleInd, rowScale,...
%                     colScale, rotation, single(T.selectedRow), single(T.selectedCol),...
%                     single(T.selectedOri), single(T.selectedScale), norient );
% 
%                 TT.selectedRow = tmpSelectedRow;
%                 tmpSelectedCol = tmpSelectedCol * reflect;
%                 TT.selectedCol = tmpSelectedCol;
%                 if reflect < 0
%                     tmpSelectedOri = norient - tmpSelectedOri;
%                 end
%                 tmpSelectedOri(tmpSelectedOri>=norient) = 0;
%                 TT.selectedOri = tmpSelectedOri;
%                 TT.selectedScale = tmpSelectedScale;
%                 TT.selectedLambda = single(T.selectedLambda);
%                 TT.selectedLogZ = single(T.selectedLogZ);
%                 TT.subsampleM1 = T.subsampleM1;
% 
%                 % render the matched template
%                 
%                 for iF = 1:min(nTex,length(TT.selectedRow))
%                     tmp_row = row_shift+TT.selectedRow(iF)+1;
%                     tmp_col = col_shift+TT.selectedCol(iF)+1;
%                     if tmp_row <= 0 || tmp_row > windowSize || tmp_col <= 0 || tmp_col > windowSize
%                         shifted_row(iF) = 1;
%                         shifted_col(iF) = 1;
%                         shifted_ori(iF) = 0;
%                         response_vec(iF) = 0;
%                         continue;
%                     end
%                     ind_shift = 1 + ARGMAX1LocalNorm{TT.selectedOri(iF)+1}(tmp_row,tmp_col);
%                     if ind_shift < 0
%                         shifted_row(iF) = 1;
%                         shifted_col(iF) = 1;
%                         shifted_ori(iF) = 0;
%                         response_vec(iF) = 0;
%                         continue;
%                     end
%                     shifted_row(iF) = double(M1RowShift{TT.selectedOri(iF)+1}(ind_shift)) + row_shift + TT.selectedRow(iF) + 1;
%                     shifted_col(iF) = double(M1ColShift{TT.selectedOri(iF)+1}(ind_shift)) + col_shift + TT.selectedCol(iF) + 1;
%                     shifted_ori(iF) = double(M1OriShifted{TT.selectedOri(iF)+1}(ind_shift));
%                     response_vec(iF) = double( S1LocalNorm{shifted_ori(iF)+1}(shifted_row(iF),shifted_col(iF)) );
%                 end
%                 sym = displayQuadGaborTemplate([windowSize windowSize], shifted_row,...
%                     shifted_col,...
%                     shifted_ori,...
%                     response_vec...
%                     );
%                 
%                 matchedTexture{count} = sym;
%                 count = count + 1;
%             end
%             matched_both = {};
%             for ii = 1:length(matchedSketch)
%                 matched_both{ii} = 255 * ones( [size(matchedSketch{ii}) 3] );
%                 matched_both{ii}(:,:,1) = matched_both{ii}(:,:,1) + double(matchedSketch{ii}) -255;
%                 matched_both{ii}(:,:,2) = matched_both{ii}(:,:,2) + double(matchedSketch{ii}) -255;
%                 matched_both{ii}(:,:,3) = matched_both{ii}(:,:,3) + double(matchedSketch{ii})-255;
%                 matched_both{ii}(:,:,2) = matched_both{ii}(:,:,2) + (double(matchedTexture{ii})-255)*.5;
%                 matched_both{ii}(:,:,3) = matched_both{ii}(:,:,3) + (double(matchedTexture{ii})-255)*.5;
%             end
%             im = displayImagesColor( [images(:)';matched_both(:)'], 2*5, 100, 100 );
%             imwrite( im, sprintf( 'matched_%s_run%d_cluster%d.png', category, iRun, cluster_ind ) );
            
            % display the template
            symSk = displayGaborTemplate([windowSize windowSize], S2Template{cluster_ind}.selectedRow(1:nSk) + floor(windowSize/2) + 1,...
				S2Template{cluster_ind}.selectedCol(1:nSk) + floor(windowSize/2) + 1, ...
				S2Template{cluster_ind}.selectedOri(1:nSk), ones(1,nSk) );
            imwrite( symSk, sprintf( 't_%s_run%d_cluster%d_sk.png', category, iRun, cluster_ind ) );
%             actual_nTex = min(length(S2TemplateTexture{cluster_ind}.selectedRow),nTex);
%             symTex = displayQuadGaborTemplate([windowSize windowSize], S2TemplateTexture{cluster_ind}.selectedRow(1:actual_nTex) + floor(windowSize/2) + 1,...
% 				S2Template{cluster_ind}.selectedCol(1:actual_nTex) + floor(windowSize/2) + 1, ...
% 				S2Template{cluster_ind}.selectedOri(1:actual_nTex), ones(1, actual_nTex));
%             sym = zeros( [size(matchedSketch{ii}) 3] );
%             sym(:,:,1) = sym(:,:,1) + double(symSk)-255;
%             sym(:,:,2) = sym(:,:,2) + double(symSk)-255;
%             sym(:,:,3) = sym(:,:,3) + double(symSk)-255;
%             sym(:,:,2) = sym(:,:,2) + (double(symTex) - 255)*.5;
%             sym(:,:,3) = sym(:,:,3) + (double(symTex) - 255)*.5;
%             towrite = sym;
%             towrite = uint8(255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));
%             imwrite( towrite, sprintf( 't_%s_run%d_cluster%d.png', category, iRun, cluster_ind ) );
        end
        
    end
end



