#include "mex.h"
#include "math.h"
/* Given: the <map> shares either the same width or the same height with the window lattice */

void inscribe(int windowWidth, int windowHeight, float* rmap, int width, int height, float* map, float val )
{
    int i, j, newSx, newSy, margin;
    
    
    for( j = 0; j < windowWidth*windowHeight; ++j )
    {
        rmap[j] = val;
    }

    if( height * windowWidth >= width * windowHeight )
    {
        newSx = windowHeight; newSy = (int) floor(.5+newSx*(float)width/(float)height );
        margin = (int)floor(((float)windowWidth-(float)newSy)/2.0);
        for( j = 0; j < width; ++j )
            for( i = 0; i < height; ++i )
            {
                rmap[(margin+j)*windowHeight+i] = map[j*height+i];
            }
        /* destImage(:,(1:newSy)+floor((rectSize(2)-newSy)/2)) = srcImage(:,:); */
    }
    else
    {
        newSy = windowWidth; newSx = (int)floor(.5+(float)newSy*(float)height/(float)width ); 
        margin = (int) floor(((float)windowHeight-(float)newSx)/2.0);
        for( j = 0; j < width; ++j )
            for( i = 0; i < height; ++i )
            {
                rmap[j*windowHeight+(margin+i)] = map[j*height+i];
            }
        /* destImage((1:newSx)+floor((rectSize(1)-newSx)/2),:) = srcImage(:,:); */
    }
}


