cd Code
mex Ctransform.c
mex Cmax.c
mex Chistog.c
mex mexc_SharedSketch.cpp
mex mexc_ComputeSUM2.cpp
mex mexc_ComputeMAX1.cpp
mex mexc_Copy.cpp
mex mexc_TemplateAffineTransform.cpp
mex mexc_CropInstance.cpp
mex mexc_ExtractSelectedFeatureResponse.cpp
cd ..

load('Split/categoryInfo.mat','categories');
load('Split/Natural/split.mat','negTestImages');
% categories = categories(1:5);
nC = length(categories);
overwrite = true;

% ! please uncomment the next line if feature computation is not done yet 
% featureConvolution('GaborS1',0.7,overwrite);

% for the other two scales
% featureConvolution('GaborS1_11',0.4,overwrite);
% featureConvolution('GaborS1_25',1,overwrite);


% ! please uncomment this code to perform pooling of background statistics
%   this is needed for learning
% natural stat
% tilt_GaborS1



%
% learning
%

for iCat = 1:nC
     for iRun = 11
         %
         % learn a template
         %
         experiment = ActiveBasisLocalNormSVM(iRun,iCat,categories);
         experiment.learn; % calls the class method learn(this) of ActiveBasisLocalNorm 
         clear experiment
     end
end


%
% visualize the templates
%
for iRun = 11
    % sketch template
	symbolicTemplates = cell(1,nC);
	nSketchToDisplay = 45;
	for iCat = 1:nC
		load(sprintf('Result/%s/ActiveBasisLocalNormSVM/model_run%d.mat', categories{iCat}, iRun), 'sym',...
			'Mx','My','Mi','Mm');
		sym = displayGaborTemplate(size(sym), Mx(1:nSketchToDisplay),...
			My(1:nSketchToDisplay), Mi(1:nSketchToDisplay), Mm(1:nSketchToDisplay) );
		symbolicTemplates{iCat} = double(sym);
	end
	templates_sym = displayImages(symbolicTemplates,10,100,100);
	if ~exist('Result/summary/ActiveBasisLocalNormSVM', 'dir')
		mkdir('Result/summary/ActiveBasisLocalNormSVM');
	end
	imwrite(templates_sym,sprintf('%s/templates_run%d.png','Result/summary/ActiveBasisLocalNormSVM', iRun));
    
    % texture template
    symbolicTemplates = cell(1,nC);
	nTextureToDisplay = 30;
	for iCat = 1:nC
		load(sprintf('Result/%s/ActiveBasisLocalNormSVM/model_run%d.mat', categories{iCat}, iRun), 'S2TemplateTexture'...
			);
		Mx = S2TemplateTexture.selectedRow(1:min(end,nTextureToDisplay)) + 1 + floor(size(sym,1)/2);
		My = S2TemplateTexture.selectedCol(1:min(end,nTextureToDisplay)) + 1 + floor(size(sym,2)/2);
		Mi = S2TemplateTexture.selectedOri(1:min(end,nTextureToDisplay));
		sym = displayGaborTemplate(size(sym), Mx,...
			My,...
            Mi,...
            ones(1,length(Mx))...
            );
		symbolicTemplates{iCat} = double(sym);
	end
	templates_sym = displayImages(symbolicTemplates,10,100,100);
	if ~exist('Result/summary/ActiveBasisLocalNormSVM', 'dir')
		mkdir('Result/summary/ActiveBasisLocalNormSVM');
	end
	imwrite(templates_sym,sprintf('%s/templatesTex_run%d.png','Result/summary/ActiveBasisLocalNormSVM', iRun));
end


% 
% prepare svm training and testing input
%
iCat = 1;
for iRun = 11
    experiment = ActiveBasisLocalNormSVM(iRun,iCat,categories);
    experiment.prepare_svmtrain_input;
    clear experiment
end



iCat = 1;
for iRun = 11
    experiment = ActiveBasisLocalNormSVM(iRun,iCat,categories);
    experiment.prepare_svmtest_input;
    clear experiment
end



iCat = 1;
for iRun = 11
    experiment = ActiveBasisLocalNormSVM(iRun,iCat,categories);
    experiment.perform_svm;
    clear experiment
end

%}

%
% evaluating (svm result)
%

for iRun = 11
     numImage = 0;
     for iCat = 1:nC
         load(sprintf('Split/%s/split%d.mat',categories{iCat},iRun),'posTestImages');
         pos{iCat} = numImage + (1 : length(posTestImages));
         numImage = numImage + length(posTestImages);
     end
     
     load(sprintf('%s/svmresult_run%d.mat','Result/summary/ActiveBasisLocalNormSVM', iRun), 'svm_prediction');

     [averageRate confusionMatrix correctRate] = getConfusionMatrix(svm_prediction,pos);
     
     for iCat = 1:nC
         predicted = svm_prediction(:,iCat) > 0;
         gt = zeros(length(predicted),1);
         gt(pos{iCat}) = 1;
         correct_vec = gt == predicted;
         binaryRecallRate(iCat) = mean( correct_vec(pos{iCat}) );
     end

	if ~exist('Result/summary/ActiveBasisLocalNormSVM', 'dir')
		mkdir('Result/summary/ActiveBasisLocalNormSVM');
	end
	save(sprintf('%s/svm_eval_result_run%d.mat','Result/summary/ActiveBasisLocalNormSVM', iRun), 'averageRate', 'confusionMatrix', 'correctRate', 'binaryRecallRate');
end

%
% evaluating
%
for iRun = 11
     numImage = 0;
     for iCat = 1:nC
         load(sprintf('Split/%s/split%d.mat',categories{iCat},iRun),'posTestImages');
         pos{iCat} = numImage + (1 : length(posTestImages));
         numImage = numImage + length(posTestImages);
     end
     
     tssMat = zeros(numImage,nC,'single');
     offset = 0;
     for iCat = 1:nC
         load(sprintf('Result/%s/ActiveBasisLocalNormSVM/out_run%d.mat', categories{iCat}, iRun),'scores');
         % load(sprintf('Result/%s/ActiveBasisLocalNormSVM/out_run%d.mat', categories{iCat}, iRun),'post_label_given_image');
         % scores = post_label_given_image;
         for i = 1:length(pos{iCat})
             tssMat(offset+i,:) = scores{i}(1,1:nC);
         end
         offset = offset + length(pos{iCat});
     end
     
     [averageRate confusionMatrix correctRate] = getConfusionMatrix(tssMat,pos);


	if ~exist('Result/summary/ActiveBasisLocalNormSVM', 'dir')
		mkdir('Result/summary/ActiveBasisLocalNormSVM');
	end
	save(sprintf('%s/eval_result_run%d.mat','Result/summary/ActiveBasisLocalNormSVM', iRun), 'averageRate', 'confusionMatrix', 'correctRate', 'tssMat');
end
